def patFoo(value: Any): Boolean = {
  value match {
    case a: Int => a % 4 == 0
    case c: Char => c.isUpper
    case b: Boolean => true
    case _ => false
  }
}

abstract class Expr
case class Number(n: Int) extends Expr
case class Sum(e1: Expr, e2: Expr) extends Expr

def eval(e: Expr): Int = e match {
  case Number(n) => n
  case Sum(e1, e2) => eval(e1) + eval(e2)
}

def show(e: Expr): String = e match {
  case Number(n) => n.toString
  case Sum(e1, e2) => "(" + show(e1) + " + " + show(e2) + ")"
}

patFoo(23)
patFoo(24)
patFoo('a')
patFoo('A')
patFoo(false)
patFoo(true)
patFoo("Hello")
patFoo(null)

val e: Expr = Sum(Number(3), Sum(Number(4), Number(5)))
eval(e)
show(e)